// Written by obaldin

#pragma once
#include "emule.h"
#include "KnownFile.h"

class CJumpstarter
{
public:
	CJumpstarter(CKnownFile *file);
	~CJumpstarter(void);

	static void OpenDatabases(DbEnv *pDbEnvironment);
	static void CloseDatabases(void);

	static bool ShouldBeEnabledForFile(CKnownFile* file);
	static bool IsJsCompleteForFile(CKnownFile* file);
	static void EnableForFile(CKnownFile* file);
	void Disable();

	void AddSentBlock(CUpDownClient *client, uint32 start_offset, uint32 togo);
	void WriteJumpstartPartStatus(CUpDownClient *client, CMemFile *file);
	bool AllowChunkForClient(uint32 partNo, CUpDownClient *client);

private:
	bool IsChunkComplete(uint32 partNo);
	uint32 NumVisibleInChunksMap(uchar *chunks_map);
	static bool ReadJsEnabled(CKnownFile *file);
	static void WriteJsEnabled(CKnownFile *file, bool enabled);

private:
	CKnownFile		*kfile;
	uint32			nParts;

	static DbEnv	*pDbEnv;
	static Db		*pDbJumpstart;
	static Db		*pDbUserBlocks;
	static Db		*pDbUserChunks;
	static Db		*pDbJSOptions;
};
